#ifndef MODEL_INCLUDED
 #define MODEL_INCLUDED

// Model.h
#include "vector3d.h"
#include <vector>
#include <string>

using namespace std;

class Polygon {
	public:
	vector <int> points;
	Vect3d normal;
};

class Model {
	private:
	vector <Vect3d> points;
	vector <Polygon> polys;
	Component minz,miny, maxz, maxy, middlez;
	Component textureScale;
	Component textureYOffset;
	public:
	// Load a blank model with only one vertex and no polys.
	Model() {
		points.resize(1);
		polys.resize(0);
		points[0] = Vect3d(0,0,0);
	}
	// Load from a file
	void load(string filename);
	// Draw with current OpenGL params
	void draw(bool texture = false) const;
	void drawTweened(bool texture, const Model & to, float distance) const;
	void drawMeTweened(bool texture, const Model & to, float distance) const;
};

#endif // MODEL_INCLUDED

