#ifndef PLAYER_INCLUDED
 #define PLAYER_INCLUDED

#include "gamemanager.h"
#include "resourcemanager.h"

class ClippedObject : public GameObject {
	protected:
		bool onGround;
	public:
		void clip();
		void processFriction();
};

class Player: public ClippedObject {
	private:
		enum State {
			Standing=1, Walking=2, Climbing=3, Dead=4
		};
		State state;
		int stateTimer; // Time before we revert to standing.
		int fireTimer;
		
		// data here?
		double azimuth; // Angle, 0=facing the camera, 90 = right, -90 = left, 180 = away
		double desiredAzimuth;
		double anim; // between 0 and 1
		ResourceManager::ModelType frame; // Which model we're on now (ish)
		ResourceManager::ModelType nextFrame; // Where we're going next.
	
		void setNextFrame();
		void processInput();
		void checkDeath();
		void doFire();
	public:
		Player();
		
		virtual void render();
		virtual void tick();
		virtual void collided(GameObject * other);
		
		virtual ~Player() { }
		
};

// The bean that we throw.

class Bean: public ClippedObject {
	private:
		// Some kind fo timer.
		float buryDepth;
		void growStalk();
	public:
		Bean();
		
		virtual void render();
		virtual void tick();
		virtual void collided(GameObject * other);
		
		virtual ~Bean() { }
};

class Treasure: public ClippedObject {
	public:
		Treasure();
		virtual void render();
		virtual void tick() { } // Nothing.
		virtual void collided(GameObject * other);
		
		virtual ~Treasure() { }
};

#endif // PLAYER_INCLUDED


